﻿// <------- xoftc.com --------->
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Windows.Forms;
using System.Diagnostics;

namespace FRMBuild
{
    public class cls_FrmBuilder : cls_FrmLoader
    {
        cls_FrmLoader FormLoad = new cls_FrmLoader(); // used for demo data and testing
        Dictionary<int, string> ObjDic = new Dictionary<int, string>(); // holds control list for action refference

        Form frm;
        Label[] lbl;
        TextBox[] txt;
        Button[] btn;

        int _nlbl = 0;
        int _ntxt = 0;
        int _nbtn = 0;
        int _iFormIndex = 0;

        int iObjectCounter = 0;

        public void MainCaller(int iFormIndex, int nlbl, int ntxt, int nbtn) // demo data passer
        {
            FormLoad.BuildData();
            BuildForm(iFormIndex, nlbl, ntxt, nbtn);
        }

        private void BuildForm(int iFormIndex, int nlbl, int ntxt, int nbtn) // builder, recievces formdata index, number of labels, n of texts and n of buttons
        {
            // <--- demo
            int iYex = 0;
            int iXex = 0;
            // --->

            frm = new Form();
            lbl = new Label[nlbl];
            txt = new TextBox[ntxt];
            btn = new Button[nbtn];

            _iFormIndex = iFormIndex - 1;
            _nlbl = nlbl;
            _ntxt = ntxt;
            _nbtn = nbtn;

            frm.Width = FormLoad.nForm[_iFormIndex].iFrmSizeX;
            frm.Height = FormLoad.nForm[_iFormIndex].iFrmSizeY;
            frm.Text = FormLoad.nForm[_iFormIndex].sFrmName;
            for (int u = iObjectCounter; u <= nlbl - 1; u++)
            {
                lbl[u] = new Label();
                lbl[u].AutoSize = false;
                lbl[u].Location = new Point(FormLoad.nForm[_iFormIndex].nObject[iObjectCounter].iOPosX + iXex, FormLoad.nForm[_iFormIndex].nObject[iObjectCounter].iOPosY + iYex);
                lbl[u].Name = FormLoad.nForm[_iFormIndex].nObject[iObjectCounter].sOName;
                lbl[u].Text = FormLoad.nForm[_iFormIndex].nObject[iObjectCounter].sOText;
                lbl[u].BackColor = Color.FromName(FormLoad.nForm[_iFormIndex].nObject[iObjectCounter].sOColorBack);
                lbl[u].ForeColor = Color.FromName(FormLoad.nForm[_iFormIndex].nObject[iObjectCounter].sOColorFront);
                lbl[u].Font = new Font(FormLoad.nForm[_iFormIndex].nObject[iObjectCounter].sOFontFamily, FormLoad.nForm[_iFormIndex].nObject[iObjectCounter].iOFontSize);
                frm.Controls.Add(lbl[u]);
                ObjDic.Add(frm.Controls.IndexOf(lbl[u]), "lbl");
                iYex = iYex + 40;
                iObjectCounter++;
            }
            iYex = 0;
            iXex = iXex + 150;
            for (int u = 0; u <= ntxt - 1; u++)
            {
                txt[u] = new TextBox();
                txt[u].AutoSize = false;
                txt[u].Location = new Point(FormLoad.nForm[_iFormIndex].nObject[iObjectCounter].iOPosX + iXex, FormLoad.nForm[_iFormIndex].nObject[iObjectCounter].iOPosY + iYex);
                txt[u].Name = FormLoad.nForm[_iFormIndex].nObject[iObjectCounter].sOName;
                txt[u].Text = FormLoad.nForm[_iFormIndex].nObject[iObjectCounter].sOText;
                txt[u].BackColor = Color.FromName(FormLoad.nForm[_iFormIndex].nObject[iObjectCounter].sOColorBack);
                txt[u].ForeColor = Color.FromName(FormLoad.nForm[_iFormIndex].nObject[iObjectCounter].sOColorFront);
                txt[u].Font = new Font(FormLoad.nForm[_iFormIndex].nObject[u].sOFontFamily, FormLoad.nForm[_iFormIndex].nObject[iObjectCounter].iOFontSize);
                frm.Controls.Add(txt[u]);
                ObjDic.Add(frm.Controls.IndexOf(txt[u]), "txt");
                iYex = iYex + 40;
                iObjectCounter++;
            }

            for (int u = 0; u <= nbtn - 1; u++)
            {
                btn[u] = new Button();
                btn[u].AutoSize = false;
                btn[u].Location = new Point(FormLoad.nForm[_iFormIndex].nObject[iObjectCounter].iOPosX + iXex, FormLoad.nForm[_iFormIndex].nObject[iObjectCounter].iOPosY + iYex);
                btn[u].Name = FormLoad.nForm[_iFormIndex].nObject[iObjectCounter].sOName;
                btn[u].Text = FormLoad.nForm[_iFormIndex].nObject[iObjectCounter].sOText;
                btn[u].BackColor = Color.FromName(FormLoad.nForm[_iFormIndex].nObject[iObjectCounter].sOColorBack);
                btn[u].ForeColor = Color.FromName(FormLoad.nForm[_iFormIndex].nObject[iObjectCounter].sOColorFront);
                btn[u].Font = new Font(FormLoad.nForm[_iFormIndex].nObject[iObjectCounter].sOFontFamily, FormLoad.nForm[_iFormIndex].nObject[iObjectCounter].iOFontSize);
                btn[u].Click += new System.EventHandler(ClickHandler); // associate ClickHandler call with object to call method module
                frm.Controls.Add(btn[u]);
                ObjDic.Add(frm.Controls.IndexOf(btn[u]), "btn");
                iYex = iYex + 40;
                iObjectCounter++;
            }
            frm.Show();
        }

        private void ClickHandler(Object sender, System.EventArgs e) // handles a click on button inside the form and gets inputdata for specific form to pass on to logic module
        {
            Button btn = sender as Button;
            string btnName = btn.Name;
            string[] sInputData = new string[_ntxt];
            string sPassDataMsg = null;
            int i = 0;
            foreach (KeyValuePair<int, string> n in ObjDic)
            {
                if (n.Value == "txt")
                {
                    sInputData[i] = btn.Parent.Controls[n.Key].Text;
                    sPassDataMsg = sPassDataMsg + "<" + sInputData[i] + ">";
                    i++;
                }
            }
            // pass to proc module(funcName)
            MessageBox.Show("The function: <" + btn.Name + "> was called from: <" + btn.Parent.Text + "> passing data: " + sPassDataMsg);
        }
    }
}
